#include "sphere.h"
#include <gl/GLU.h>

Sphere::Sphere(int ID, QString name, int tesselation) : Primitive(ID, name, tesselation)
{
    qDebug() << "adding sphere " << ID;
}

Sphere::~Sphere(){

}

void Sphere::drawPrimitive(){
    GLfloat specularColor[] = { 0.3, 0.5, 0.5 };
    GLfloat shininess[] = { 120 };//specular exponent
    glMaterialfv(GL_FRONT, GL_SPECULAR, specularColor);
    glMaterialfv(GL_FRONT, GL_SHININESS, shininess);

    GLfloat sphereColor[] = { 0, 0.8, 0.8 };
    glMaterialfv(GL_FRONT, GL_DIFFUSE, sphereColor);
    glNormal3f(0, 0, 1);

    glBegin(GL_LINE_LOOP);
    GLUquadric* q = gluNewQuadric();
//    gluQuadricDrawStyle(q, GLU_FILL);
    gluSphere(q, 0.5, tesselation, tesselation);


    glEnd();
}
